
// đọc  góc Y từ mpu6050 sử dụng bộ lọc bù
program example;
uses STArduino, STWire;
const RAD2DEG = 57.295779;
const OFFSET = 0;
var
	xAngle, yAngle :  real;	
	preTime : longint;

procedure MPUConfig;
begin
	wireBegin;
	wireBeginTransmission($68);
	wireWriteByte($6B);
	wireWriteByte(0);
	wireEndTransmissionStop(true);

	wireBeginTransmission($68);
	wireWriteByte($19);
	wireWriteByte(0);
	wireEndTransmissionStop(true);

	wireBeginTransmission($68);
	wireWriteByte($1B);
	wireWriteByte(0);
	wireEndTransmissionStop(true);

	wireBeginTransmission($68);
	wireWriteByte($1C);
	wireWriteByte(0);
	wireEndTransmissionStop(true);
	
	preTime := millis;
end;

procedure setup;
begin
	MPUConfig;		
	serialBegin(115200);
end;

function getYAngle:real;
var
	timeNow: longint;
	accRawX, accRawY, accRawZ, gyroRawX, gyroRawY: integer;
	gyroXAngle,gyroYAngle, accelerationXAngle,accelerationYAngle : real;
begin
	
	wireBeginTransmission($68);
	wireWriteByte($3B);
	wireEndTransmissionStop(false);
	wireRequestFromStop($68, 12, true);
	
	accRawX := (wireRead shl 8) or wireRead;
	accRawY := (wireRead shl 8) or wireRead;
	accRawZ := (wireRead shl 8) or wireRead;
	
	wireRead;  wireRead;
	
	gyroRawX := (wireRead shl 8) or wireRead;
  	gyroRawY := (wireRead shl 8) or wireRead;

	accelerationXAngle := arctan((accRawY / 16384.0) / sqrt(pow((accRawX / 16384.0), 2) + pow((accRawZ / 16384.0), 2))) * RAD2DEG;
	accelerationYAngle := arctan(-1 * (accRawX / 16384.0) / sqrt(pow((accRawY / 16384.0), 2) + pow((accRawZ / 16384.0), 2))) * RAD2DEG;
	
  	gyroXAngle := gyroRawX / 131.0;
  	gyroYAngle := gyroRawY / 131.0;
  	timeNow := millis;
  	//xAngle := 0.98 * (xAngle + gyroXAngle * (timeNow - preTime) / 1000) + 0.02 * accelerationXAngle;
  	yAngle := 0.98 * (yAngle + gyroYAngle * (timeNow - preTime) / 1000) + 0.02 * accelerationYAngle;
  	preTime := millis;
  	getYAngle := yAngle + OFFSET;

end;

procedure loop;
var angle : real;
begin
	angle := getYAngle;
	serialPrintlnReal(round(angle));
	delay(3);
end;

begin
end.
