program Bai9;
uses STArduino;
const
	TRIGPIN = 51;
	ECHOPIN = 53;
	TIMEOUT = 4000;		// đơn vị (us)
procedure setup;
begin
	serialBegin(115200);
	pinMode(TRIGPIN, OUTPUT);
	pinMode(ECHOPIN, INPUT);
end;
function getDistance: real;
var 
	pulseWidth: real;
	
begin
	digitalWrite(TRIGPIN,LOW);   // tắt chân TRIG
  	delayMicroseconds(2);
  	digitalWrite(TRIGPIN,HIGH);   // phát xung từ chân TRIG
  	delayMicroseconds(10);     // xung có độ dài 10 microSeconds
  	digitalWrite(TRIGPIN,LOW);    // tắt chân TRIG
  
  	// Tính toán thời gian */
  	// Đo độ rộng xung HIGH ở chân ECHO. 
  	pulseWidth := pulseInTimeout(ECHOPIN, HIGH, TIMEOUT);  
	{ 
	   TIMEOUT là thời gian tối đa để thoát khỏi hàm pulseIn.
	   Nếu khoảng cách vật cản càng xa (trong tầm đo của cảm biến) thì hàm pulseIn càng tốn thời gian để thực hiện.
	   Mặc định, nếu ta không truyền TIMEOUT thì thời gian tối đa để thoát khỏi hàm này là khoảng 200 (ms)
	   Điều này không tốt cho xe cân bằng vì đòi hỏi phải cần tính toán nhanh,
	   trong khi pulseIn sẽ làm trì hoãn thời gian tính toán để đo khoảng cách.
	   Vì vậy ta phải thiết lập thời gian tối đa của hàm pulseIn để xe vừa có thể thực hiện 
	   nhiệm vụ cân bằng và vừa tính được khoảng cách sao cho hợp lý. 
    }
  
  	// Tính khoảng cách đến vật.
  	getDistance := (pulseWidth/2/29.411);
end;
procedure loop;
begin
	serialPrintReal(round(getDistance));
	serialPrintString(' cm');
	serialPrintlnString(' ');
	delay(200);
end;

begin
end.
